/**
 * Run a value through an array of asyncronous, non-mutational functions.
 *
 * @remarks
 * Unlike {@link Bud.pipe} the value returned from each function is ignored.
 */
export const sequence = async function (fns) {
    const app = this;
    await fns.reduce(async (promised, fn) => {
        await promised;
        await fn(app);
    }, Promise.resolve());
    return app;
};
/**
 * Run a value through an array of syncronous, non-mutational functions.
 *
 * @remarks
 * Unlike {@link pipe} the value returned from each function is ignored.
 */
export const sequenceSync = (fns) => {
    fns.map(fn => fn.call(this, this));
    return this;
};
